<template>
  <div
    ref="backTopButton"
    class="main"
  >
    <div
        class="back-button"
    >
      <button @click="backToTop">
      {{ $t('backTopButton.text') }}
      </button>
    </div>
  </div>
</template>

<script>
  import { defineComponent } from "vue";

  export default defineComponent({
    mounted() {
      window.addEventListener("scroll", this.handleBack);
    },

    beforeUnmount() {
      window.removeEventListener("scroll", this.handleBack);
    },

    methods: {
      handleBack() {
        const backBtn = this.$refs.backTopButton;

          if (window.scrollY > 0) {
            backBtn.classList.remove("invisible");
          } else {
            backBtn.classList.add("invisible");
          }
      },
      backToTop() {
        window.scrollTo({ top: 0, behavior: "smooth" });
      },
    },
  });
</script>

<style lang="postcss" scoped>
.main {
  @layer invisible;
  @apply sticky transition;
  @apply w-full bottom-0 pb-3 pr-5;
  @apply flex justify-end;
}

.back-button {
  @apply text-gray-400;
  @apply hover:text-purple-400 transition;
}
</style>